﻿using UnityEngine;
using System.Collections;

public class FindRaftCenter : Mod
{
    AssetBundle assets;
    GameObject marker;

    public IEnumerator Start()
    {
        AssetBundleCreateRequest request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("findraftcenter.assets"));
        yield return request;
        assets = request.assetBundle;

        if (ComponentManager<Raft>.Value) {
            LoadingCylinder();
        }
        
        Debug.Log("FindRaftCenter has been loaded!");
    }

    public override void WorldEvent_WorldLoaded()
    {
        LoadingCylinder();
    }

    public void LoadingCylinder()
    {
        GameObject cylinderAsset = assets.LoadAsset<GameObject>("Cylinder");
        marker = Instantiate(cylinderAsset);
        marker.transform.localScale = new Vector3(0.3f, 4f, 0.3f);

        marker.transform.SetParent(ComponentManager<Raft>.Value.gameObject.transform, false);

        Debug.Log("Center shown!");
    }

    public void OnModUnload()
    {
        if (marker)
        {
            Destroy(marker);
        }
        if (assets)
        {
            assets.Unload(true);
        }
        Debug.Log("FindRaftCenter has been unloaded!");
    }
}